//RSSI-test

#include <Arduino.h>
#include <Adafruit_TinyUSB.h>
#include <bluefruit.h>

bool readingFlag_1 = false;

//connection variables
uint16_t conn_hdl_1;
bool connected_1 = false;
bool discovered_1 = false;

//sensor variables etc.
int8_t ss_1;

#define data1Service_UUID(val) \
  (const uint8_t[]) { \
    0x7f, 0x6e, 0xcf, 0xce, 0xe6, 0x07, 0x5c, 0xbf, 0xbc, 0x45, \
    (uint8_t) (val & 0xff), (uint8_t) (val >> 8), 0xa1, 0x1a, 0xe2, 0xa4  \
  }
//Client 1
BLEClientService        data1Service        (data1Service_UUID(0x0000));
BLEClientCharacteristic data1Characteristic (data1Service_UUID(0x0030));

void setup()
{
  Serial.begin(115200);
  
  while(!Serial);
  
  Bluefruit.begin(0,1);  //begin(uint8_t prph_count, uint8_t central_count)
  Bluefruit.setTxPower(8);    //-40dBm, -20dBm, -16dBm, -12dBm, -8dBm, -4dBm, 0dBm, +2dBm, +3dBm, +4dBm, +5dBm, +6dBm, +7dBm and +8dBm.
  Bluefruit.setName("dataService Central"); //sd_ble_gap_device_name_set

  //Service initialization
  data1Service.begin();
  data1Characteristic.begin();

  //Callbacks
  Bluefruit.Central.setConnectCallback(connect_callback);       //*****************

  //scan settings
  Bluefruit.Scanner.setRxCallback(scan_callback);               //*****************
  Bluefruit.Scanner.restartOnDisconnect(true);
  Bluefruit.Scanner.filterRssi(-99);
  Bluefruit.Scanner.setIntervalMS(100, 50);     //interval:100mS  window:50mS
  Bluefruit.Scanner.filterUuid(data1Service.uuid);
  Bluefruit.Scanner.useActiveScan(false);
  Bluefruit.Scanner.start(0);                   //continous scan

}

//**************************************************************************************************
void loop()
{
  
  // Get the reference to current connected connection
  uint16_t conn_hdl_1 = data1Characteristic.connHandle();

  // get the RSSI value of this connection
  // monitorRssi() must be called previously (in connect callback)
  BLEConnection* connection_1 = Bluefruit.Connection(conn_hdl_1);
  ss_1 = connection_1->getRssi();
  if(ss_1 != 0){
    Serial.println(ss_1);  
  }

}

//**************************************************************************************************
//*****************************************************************************************************
// * Callback invoked when scanner pick up an advertising data
// * @param report Structural advertising data
void scan_callback(ble_gap_evt_adv_report_t* report)
{
  discovered_1 = false;
  Bluefruit.Central.connect(report);      //  return connect(&adv_report->peer_addr);

  if ( Bluefruit.Scanner.checkReportForUuid(report, data1Service.uuid))
  {
    Serial.println("data1Service");
    discovered_1 = true;
  }
}

//****************************************************************************************************:
// * Callback invoked when an connection is established
// * @param conn_handle
void connect_callback(uint16_t conn_handle)
{
  //digitalWrite(LED_GREEN, LOW);

  //RSSIモニタの起動
  BLEConnection* conn = Bluefruit.Connection(conn_handle);
  conn->monitorRssi();

  if (data1Service.discover(conn_handle)) //-----------------------------------------------------
  {

    Serial.println("Connected_1 ........");
    if ( !data1Service.discover(conn_handle) )              // Service.discover
    {
      Serial.println("Service_1 not find disconnect!");
      Bluefruit.disconnect(conn_handle);
      //    return;
    }


    if ( !data1Characteristic.discover() )            // Characteristic.discover
    {
      Serial.println("Characteristic_1 not find disconnect!");
      Bluefruit.disconnect(conn_handle);
      //    return;
    }

    if ( data1Characteristic.enableNotify() )
    {
      Serial.println("Ready to receive datapacket_1");
    }
    else
    {
      Serial.println("Couldn't enable notify for datapacket_1");
    }
    connected_1 = true;
  }



  Serial.println("connect_callback end");

  if (connected_1) {
    Bluefruit.Scanner.stop();
  }
  else {
    Bluefruit.Scanner.start(0);
  }

}
