//RSSI-test

#include <Arduino.h>
#include <Adafruit_TinyUSB.h>
#include <bluefruit.h>

#define dataNum 12

union unionData {
  float   dataBuff32[dataNum/4];
  uint8_t   dataBuff8[dataNum];
};
union unionData ud;

boolean connectFlag = false;

#define data1Service_UUID(val) \
  (const uint8_t[]) { \
    0x7f, 0x6e, 0xcf, 0xce, 0xe6, 0x07, 0x5c, 0xbf, 0xbc, 0x45, \
    (uint8_t) (val & 0xff), (uint8_t) (val >> 8), 0xa1, 0x1a, 0xe2, 0xa4  \
  }

BLEService        data1Service          (data1Service_UUID(0x0000));
BLECharacteristic data1Characteristic   (data1Service_UUID(0x0030));

void setup() {
  Serial.begin(115200);
  
  //while(!Serial);
  
  //Bruefruitクラスの初期化
  Bluefruit.configPrphBandwidth(BANDWIDTH_MAX);
  Bluefruit.configUuid128Count(15);
  Serial.println(1);

  Bluefruit.begin();
  Bluefruit.setTxPower(8);    //-40dBm, -20dBm, -16dBm, -12dBm, -8dBm, -4dBm, 0dBm, +2dBm, +3dBm, +4dBm, +5dBm, +6dBm, +7dBm and +8dBm.
  Bluefruit.Periph.setConnectCallback(connect_callback);
  Serial.println(2);

  //カスタムサービスの設定
  data1Service.begin();

  data1Characteristic.setProperties(CHR_PROPS_NOTIFY | CHR_PROPS_READ);
  data1Characteristic.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  data1Characteristic.setFixedLen(dataNum);
  data1Characteristic.begin();
  Serial.println(3);

  //アドバタイスの設定
  Bluefruit.Advertising.addFlags(BLE_GAP_ADV_FLAGS_LE_ONLY_GENERAL_DISC_MODE);
  Bluefruit.Advertising.addTxPower();
  Bluefruit.Advertising.addService(data1Service);
  Bluefruit.ScanResponse.addName();
  Serial.println(4);
  
  // Start Advertising
  Bluefruit.Advertising.restartOnDisconnect(true);
  Bluefruit.Advertising.setIntervalMS(20, 153);    // in unit of 0.625 ms  20mS:153mS
  Bluefruit.Advertising.setFastTimeout(30);      // number of seconds in fast mode
  Bluefruit.Advertising.start(0);                // 0 = Don't stop advertising after n seconds
  Serial.println(5);
  
}

void loop() 
{
    if (Bluefruit.connected()) {
      Serial.println("connected");
      
      if(!connectFlag){
        connectFlag = true;
      }

      ud.dataBuff32[0] = 1;
      ud.dataBuff32[1] = 2;
      ud.dataBuff32[2] = 3; 
      data1Characteristic.notify(ud.dataBuff8, dataNum);                
    }
}

// callback invoked when central connects
void connect_callback(uint16_t conn_handle)
{
  // Get the reference to current connection
  BLEConnection* connection = Bluefruit.Connection(conn_handle);

  char central_name[32] = { 0 };
  connection->getPeerName(central_name, sizeof(central_name));

  Serial.print("Connected to ");
  Serial.println(central_name);
}
